// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef WATCHDOG_APB_WRAPPER_HH
#define WATCHDOG_APB_WRAPPER_HH

#include <cstddef>
#include <stdint.h>

class watchdog_apb_wrapper
{

public:

    uint32_t pwdata_old;
    bool pwrite_old;
    bool penable_old;
    bool psel_old;
    uint32_t paddr_old;
    bool presetn_old;
    bool pclk_old;
    struct watchdog_apb_wrapper_iostruct{
        bool * pclk;
        bool * presetn;
        uint32_t * paddr;
        bool * psel;
        bool * penable;
        bool * pwrite;
        uint32_t * pwdata;
        bool * pready;
        uint32_t * prdata;

        watchdog_apb_wrapper_iostruct():
            pclk(nullptr),
            presetn(nullptr),
            paddr(nullptr),
            psel(nullptr),
            penable(nullptr),
            pwrite(nullptr),
            pwdata(nullptr),
            pready(nullptr),
            prdata(nullptr)
        {}

        watchdog_apb_wrapper_iostruct( bool * pclk_6, bool * presetn_6, uint32_t
             * paddr_6, bool * psel_6, bool * penable_6, bool * pwrite_6, uint32_t
             * pwdata_6, bool * pready_6, uint32_t * prdata_6 ):
            pclk(pclk_6),
            presetn(presetn_6),
            paddr(paddr_6),
            psel(psel_6),
            penable(penable_6),
            pwrite(pwrite_6),
            pwdata(pwdata_6),
            pready(pready_6),
            prdata(prdata_6)
        {}

        ~watchdog_apb_wrapper_iostruct()
        {}

        bool operator == (const watchdog_apb_wrapper_iostruct & other) const
        {
            if (pclk != other.pclk) return false;
            if (presetn != other.presetn) return false;
            if (paddr != other.paddr) return false;
            if (psel != other.psel) return false;
            if (penable != other.penable) return false;
            if (pwrite != other.pwrite) return false;
            if (pwdata != other.pwdata) return false;
            if (pready != other.pready) return false;
            if (prdata != other.prdata) return false;
            return true;
        }
    };
    watchdog_apb_wrapper_iostruct hif_a2t_data;
    bool prdata_mspw[32L];
    uint16_t prdata_partial2;
    bool prdata_partial1;
    uint16_t prdata_partial0;
    bool start_counting;
    bool stop_counting;
    uint16_t max_counter;
    uint16_t actual_counter;
    bool counter_flag;
    bool dout_rdy;
    uint8_t watchdog_0_state;
    uint8_t old_watchdog_0_state;
    uint8_t watchdog_0_state_sig_var;
    uint8_t watchdog_0_next_state;
    uint32_t watchdog_0_internal_max_counter;

    void hif_cone_max_counter();


    void hif_cone_prdata_partial0();


    void hif_cone_prdata_partial1();


    void hif_cone_start_counting();


    void hif_cone_stop_counting();


    void hif_cone_watchdog_0_state();

    watchdog_apb_wrapper();


    ~watchdog_apb_wrapper();


    bool prdata_mspw_new[32L];
    uint16_t prdata_partial2_new;
    uint16_t actual_counter_new;
    bool counter_flag_new;
    bool dout_rdy_new;
    uint8_t watchdog_0_state_new;
    uint8_t watchdog_0_next_state_new;
    uint32_t watchdog_0_internal_max_counter_new;
    bool process_in_queue;
    bool flag_watchdog_0_initial_process_executed;
    bool flag_watchdog_0_process_executed;
    bool flag_watchdog_0_state;
    bool flag_pwdata;
    bool flag_watchdog_0_process_0_executed;
    bool flag_pos_pclk;
    bool flag_dout_rdy;
    bool flag_globact_process_0_executed;
    bool flag_actual_counter;
    bool flag_globact_process_1_executed;
    bool flag_counter_flag;
    bool flag_globact_process_2_executed;
    bool flag_prdata_partial2;
    bool flag_prdata_mspw;

    void watchdog_0_initial_process();


    void watchdog_0_process();


    void watchdog_0_process_0();


    void globact_process();


    void globact_process_0();


    void globact_process_1();


    void globact_process_2();


    void prdata_mspw_proc_tgt();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();

    const uint8_t watchdog_0_st_1;
    const uint8_t watchdog_0_st_2;
    const uint8_t watchdog_0_st_3;
    const uint8_t watchdog_0_st_4;
    const uint8_t watchdog_0_st_5;


private:

    watchdog_apb_wrapper( const watchdog_apb_wrapper & );
    const watchdog_apb_wrapper& operator= ( const watchdog_apb_wrapper & );



};


#endif

